"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.DependencyMultiError = exports.DependencyMultiErrorType = exports.DependencyError = exports.DependencyErrorType = void 0;
var DependencyErrorType;
(function (DependencyErrorType) {
    DependencyErrorType["Existence"] = "'{name}' has not been added to dependency container, but it was supposed to, wasn't it?";
    DependencyErrorType["Circular"] = "'{name}' has circular dependency, two dependencies cannot depend on each other no matter how long the chain is between them";
    DependencyErrorType["Duplicate"] = "'{name}' has already been added to dependency container, use tryAdd if you might be adding it in multiple places";
    DependencyErrorType["Unknown"] = "'{name}' has not been included as key in the provider, if classname differ from provider name remember to select it via name in the options parameter";
})(DependencyErrorType = exports.DependencyErrorType || (exports.DependencyErrorType = {}));
var DependencyError = /** @class */ (function (_super) {
    __extends(DependencyError, _super);
    function DependencyError(_a) {
        var type = _a.type, lifetime = _a.lifetime;
        var _this = this;
        var name = (typeof lifetime === 'string' ? lifetime : lifetime.name).toLowerCase();
        _this = _super.call(this, type.toString().replace('{name}', name)) || this;
        _this.type = type;
        _this.lifetime = name;
        return _this;
    }
    return DependencyError;
}(Error));
exports.DependencyError = DependencyError;
var DependencyMultiErrorType;
(function (DependencyMultiErrorType) {
    DependencyMultiErrorType["Build"] = "Found errors while building provider\n{errors}";
    DependencyMultiErrorType["Validation"] = "Provider validation failed with\n{errors}";
})(DependencyMultiErrorType = exports.DependencyMultiErrorType || (exports.DependencyMultiErrorType = {}));
var DependencyMultiError = /** @class */ (function (_super) {
    __extends(DependencyMultiError, _super);
    function DependencyMultiError(type, errors) {
        return _super.call(this, type.toString().replace('{errors}', errors.map(function (e) { return e.message; }).join('\n'))) || this;
    }
    return DependencyMultiError;
}(Error));
exports.DependencyMultiError = DependencyMultiError;
