import { Container } from './Container';
export declare type Factory<T, E> = (provider: E) => T;
export interface ILifetime<T, E> {
    readonly className: string;
    readonly providerName: string;
    provide(): T;
}
export declare class Singleton<T, E> implements ILifetime<T, E> {
    readonly className: string;
    readonly providerName: string;
    private value?;
    private readonly factoryFunction;
    private readonly container;
    constructor(container: Container<E>, className: string, providerName: string, factoryFunction: Factory<T, E>);
    provide(): T;
}
export declare class Transient<T, E> implements ILifetime<T, E> {
    readonly className: string;
    readonly providerName: string;
    private readonly factory;
    private container;
    constructor(container: Container<E>, className: string, providerName: string, factoryFunction: Factory<T, E>);
    provide(): T;
}
